Index: /orxonox/trunk/src/defs/debug.h
===================================================================
--- /orxonox/trunk/src/defs/debug.h	(revision 4286)
+++ /orxonox/trunk/src/defs/debug.h	(revision 4287)
@@ -56,21 +56,22 @@
 // DEFINE MODULES
 #define DEBUG_MODULE_ORXONOX            0
-#define DEBUG_MODULE_WORLD              1
-#define DEBUG_MODULE_PNODE              1
+#define DEBUG_MODULE_WORLD              0
+#define DEBUG_MODULE_PNODE              0
 #define DEBUG_MODULE_WORLD_ENTITY       0
-#define DEBUG_MODULE_COMMAND_NODE       4
+#define DEBUG_MODULE_COMMAND_NODE       0
 #define DEBUG_MODULE_GRAPHICS           0
 #define DEBUG_MODULE_LOAD               2
 
-#define DEBUG_MODULE_IMPORTER           3
+#define DEBUG_MODULE_IMPORTER           0
 #define DEBUG_MODULE_TRACK_MANAGER      0
 #define DEBUG_MODULE_GARBAGE_COLLECTOR  0
+#define DEBUG_MODULE_OBJECT_MANAGER     3
 #define DEBUG_MODULE_LIGHT              0
 #define DEBUG_MODULE_PLAYER             1
-#define DEBUG_MODULE_WEAPON             3
+#define DEBUG_MODULE_WEAPON             0
 #define DEBUG_MODULE_MATH               0
 #define DEBUG_MODULE_FONT               1
 #define DEBUG_MODULE_ANIM               1
-#define DEBUG_MODULE_PARTICLE           4
+#define DEBUG_MODULE_PARTICLE           1
 
 #define DEBUG_MODULE_NULL_PARENT        0
Index: /orxonox/trunk/src/story_entities/world.cc
===================================================================
--- /orxonox/trunk/src/story_entities/world.cc	(revision 4286)
+++ /orxonox/trunk/src/story_entities/world.cc	(revision 4287)
@@ -40,4 +40,5 @@
 #include "track_manager.h"
 #include "garbage_collector.h"
+#include "object_manager.h"
 #include "animation_player.h"
 #include "particle_engine.h"
@@ -54,4 +55,6 @@
 
 #include "factory.h"
+
+#include "projectile.h"
 
 using namespace std;
Index: /orxonox/trunk/src/util/object_manager.cc
===================================================================
--- /orxonox/trunk/src/util/object_manager.cc	(revision 4286)
+++ /orxonox/trunk/src/util/object_manager.cc	(revision 4287)
@@ -77,2 +77,18 @@
 BaseObject* ObjectManager::getFromDeadList(const char* className, int number)
 {}
+
+
+void ObjectManager::debug()
+{
+  PRINT(0)("\n==========================| ObjectManager::debug() |===\n");
+  PRINT(0)("=  Number of registerable classes: %i\n", CL_NUMBER );  
+  PRINT(0)("=  Currently cached objects: \n");
+  for(int i = 0; i < CL_NUMBER; ++i)
+    {
+      if(this->managedObjectList[i] != NULL)
+	PRINT(0)("=   o Class Nr. %i has cached %i object(s)\n", i, this->managedObjectList[i]->getSize());
+      else
+	PRINT(0)("=   o Class Nr. %i has cached 0 object(s)\n", i);
+    }
+  PRINT(0)("=======================================================\n");
+}
Index: /orxonox/trunk/src/util/object_manager.h
===================================================================
--- /orxonox/trunk/src/util/object_manager.h	(revision 4286)
+++ /orxonox/trunk/src/util/object_manager.h	(revision 4287)
@@ -44,4 +44,6 @@
   BaseObject* getFromDeadList(const char* className, int number = 1);
 
+  void debug();
+
  private:
   ObjectManager(void);
Index: /orxonox/trunk/src/world_entities/player.cc
===================================================================
--- /orxonox/trunk/src/world_entities/player.cc	(revision 4286)
+++ /orxonox/trunk/src/world_entities/player.cc	(revision 4287)
@@ -27,4 +27,7 @@
 #include "list.h"
 #include "stdincl.h"
+
+#include "object_manager.h"
+#include "projectile.h"
 
 using namespace std;
@@ -59,5 +62,4 @@
   this->weaponMan->addWeapon(wpRight, W_CONFIG2);
   this->weaponMan->addWeapon(wpLeft, W_CONFIG2);
-
 }
 
@@ -104,4 +106,9 @@
   this->weaponMan->addWeapon(wpRight, W_CONFIG2);
   this->weaponMan->addWeapon(wpLeft, W_CONFIG2);
+
+  BaseObject* p = new Projectile(wpRight);
+  ObjectManager::getInstance()->cache(CL_PROJECTILE, 100, *p);
+  ObjectManager::getInstance()->debug();
+
 }
 
Index: /orxonox/trunk/src/world_entities/test_gun.cc
===================================================================
--- /orxonox/trunk/src/world_entities/test_gun.cc	(revision 4286)
+++ /orxonox/trunk/src/world_entities/test_gun.cc	(revision 4287)
@@ -31,4 +31,5 @@
 #include "list.h"
 #include "animation3d.h"
+
 
 using namespace std;