Index: /orxonox/branches/physics/src/lib/graphics/light.h
===================================================================
--- /orxonox/branches/physics/src/lib/graphics/light.h	(revision 4297)
+++ /orxonox/branches/physics/src/lib/graphics/light.h	(revision 4298)
@@ -11,5 +11,5 @@
 #define _LIGHT_H
 
-#include "world_entity.h"
+#include "p_node.h"
 #include "glincl.h"
 
@@ -21,5 +21,5 @@
 
 //! A class that handles Lights. The LightManager operates on this.
-class Light : public WorldEntity
+class Light : public PNode
 {
  public:
Index: /orxonox/branches/physics/src/subprojects/particles/Makefile.am
===================================================================
--- /orxonox/branches/physics/src/subprojects/particles/Makefile.am	(revision 4297)
+++ /orxonox/branches/physics/src/subprojects/particles/Makefile.am	(revision 4298)
@@ -40,4 +40,5 @@
 		  $(MAINSRCDIR)/lib/graphics/particles/particle_system.cc \
 		  $(MAINSRCDIR)/lib/graphics/particles/particle_emitter.cc \
+		  $(MAINSRCDIR)/lib/graphics/light.cc \
 		  $(MAINSRCDIR)/util/state.cc \
 		  $(MAINSRCDIR)/world_entities/camera.cc \
Index: /orxonox/branches/physics/src/subprojects/particles/Makefile.in
===================================================================
--- /orxonox/branches/physics/src/subprojects/particles/Makefile.in	(revision 4297)
+++ /orxonox/branches/physics/src/subprojects/particles/Makefile.in	(revision 4298)
@@ -55,10 +55,10 @@
 am_particles_OBJECTS = framework.$(OBJEXT) particle_engine.$(OBJEXT) \
 	particle_system.$(OBJEXT) particle_emitter.$(OBJEXT) \
-	state.$(OBJEXT) camera.$(OBJEXT) model.$(OBJEXT) \
-	objModel.$(OBJEXT) primitive_model.$(OBJEXT) array.$(OBJEXT) \
-	material.$(OBJEXT) texture.$(OBJEXT) graphics_engine.$(OBJEXT) \
-	base_object.$(OBJEXT) vector.$(OBJEXT) \
-	resource_manager.$(OBJEXT) text_engine.$(OBJEXT) \
-	p_node.$(OBJEXT) null_parent.$(OBJEXT)
+	light.$(OBJEXT) state.$(OBJEXT) camera.$(OBJEXT) \
+	model.$(OBJEXT) objModel.$(OBJEXT) primitive_model.$(OBJEXT) \
+	array.$(OBJEXT) material.$(OBJEXT) texture.$(OBJEXT) \
+	graphics_engine.$(OBJEXT) base_object.$(OBJEXT) \
+	vector.$(OBJEXT) resource_manager.$(OBJEXT) \
+	text_engine.$(OBJEXT) p_node.$(OBJEXT) null_parent.$(OBJEXT)
 particles_OBJECTS = $(am_particles_OBJECTS)
 particles_DEPENDENCIES = $(MAINSRCDIR)/lib/physics/libORXphysics.a
@@ -70,7 +70,7 @@
 @AMDEP_TRUE@	./$(DEPDIR)/framework.Po \
 @AMDEP_TRUE@	./$(DEPDIR)/graphics_engine.Po \
-@AMDEP_TRUE@	./$(DEPDIR)/material.Po ./$(DEPDIR)/model.Po \
-@AMDEP_TRUE@	./$(DEPDIR)/null_parent.Po ./$(DEPDIR)/objModel.Po \
-@AMDEP_TRUE@	./$(DEPDIR)/p_node.Po \
+@AMDEP_TRUE@	./$(DEPDIR)/light.Po ./$(DEPDIR)/material.Po \
+@AMDEP_TRUE@	./$(DEPDIR)/model.Po ./$(DEPDIR)/null_parent.Po \
+@AMDEP_TRUE@	./$(DEPDIR)/objModel.Po ./$(DEPDIR)/p_node.Po \
 @AMDEP_TRUE@	./$(DEPDIR)/particle_emitter.Po \
 @AMDEP_TRUE@	./$(DEPDIR)/particle_engine.Po \
@@ -207,4 +207,5 @@
 		  $(MAINSRCDIR)/lib/graphics/particles/particle_system.cc \
 		  $(MAINSRCDIR)/lib/graphics/particles/particle_emitter.cc \
+		  $(MAINSRCDIR)/lib/graphics/light.cc \
 		  $(MAINSRCDIR)/util/state.cc \
 		  $(MAINSRCDIR)/world_entities/camera.cc \
@@ -295,4 +296,5 @@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/framework.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/graphics_engine.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/light.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/material.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/model.Po@am__quote@
@@ -373,4 +375,20 @@
 @AMDEP_TRUE@@am__fastdepCXX_FALSE@	$(CXXDEPMODE) $(depcomp) @AMDEPBACKSLASH@
 @am__fastdepCXX_FALSE@	$(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(AM_CXXFLAGS) $(CXXFLAGS) -c -o particle_emitter.obj `if test -f '$(MAINSRCDIR)/lib/graphics/particles/particle_emitter.cc'; then $(CYGPATH_W) '$(MAINSRCDIR)/lib/graphics/particles/particle_emitter.cc'; else $(CYGPATH_W) '$(srcdir)/$(MAINSRCDIR)/lib/graphics/particles/particle_emitter.cc'; fi`
+
+light.o: $(MAINSRCDIR)/lib/graphics/light.cc
+@am__fastdepCXX_TRUE@	if $(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(AM_CXXFLAGS) $(CXXFLAGS) -MT light.o -MD -MP -MF "$(DEPDIR)/light.Tpo" -c -o light.o `test -f '$(MAINSRCDIR)/lib/graphics/light.cc' || echo '$(srcdir)/'`$(MAINSRCDIR)/lib/graphics/light.cc; \
+@am__fastdepCXX_TRUE@	then mv -f "$(DEPDIR)/light.Tpo" "$(DEPDIR)/light.Po"; else rm -f "$(DEPDIR)/light.Tpo"; exit 1; fi
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	source='$(MAINSRCDIR)/lib/graphics/light.cc' object='light.o' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	depfile='$(DEPDIR)/light.Po' tmpdepfile='$(DEPDIR)/light.TPo' @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	$(CXXDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCXX_FALSE@	$(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(AM_CXXFLAGS) $(CXXFLAGS) -c -o light.o `test -f '$(MAINSRCDIR)/lib/graphics/light.cc' || echo '$(srcdir)/'`$(MAINSRCDIR)/lib/graphics/light.cc
+
+light.obj: $(MAINSRCDIR)/lib/graphics/light.cc
+@am__fastdepCXX_TRUE@	if $(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(AM_CXXFLAGS) $(CXXFLAGS) -MT light.obj -MD -MP -MF "$(DEPDIR)/light.Tpo" -c -o light.obj `if test -f '$(MAINSRCDIR)/lib/graphics/light.cc'; then $(CYGPATH_W) '$(MAINSRCDIR)/lib/graphics/light.cc'; else $(CYGPATH_W) '$(srcdir)/$(MAINSRCDIR)/lib/graphics/light.cc'; fi`; \
+@am__fastdepCXX_TRUE@	then mv -f "$(DEPDIR)/light.Tpo" "$(DEPDIR)/light.Po"; else rm -f "$(DEPDIR)/light.Tpo"; exit 1; fi
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	source='$(MAINSRCDIR)/lib/graphics/light.cc' object='light.obj' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	depfile='$(DEPDIR)/light.Po' tmpdepfile='$(DEPDIR)/light.TPo' @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	$(CXXDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCXX_FALSE@	$(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(AM_CXXFLAGS) $(CXXFLAGS) -c -o light.obj `if test -f '$(MAINSRCDIR)/lib/graphics/light.cc'; then $(CYGPATH_W) '$(MAINSRCDIR)/lib/graphics/light.cc'; else $(CYGPATH_W) '$(srcdir)/$(MAINSRCDIR)/lib/graphics/light.cc'; fi`
 
 state.o: $(MAINSRCDIR)/util/state.cc
Index: /orxonox/branches/physics/src/subprojects/particles/framework.cc
===================================================================
--- /orxonox/branches/physics/src/subprojects/particles/framework.cc	(revision 4297)
+++ /orxonox/branches/physics/src/subprojects/particles/framework.cc	(revision 4298)
@@ -48,6 +48,4 @@
 bool Framework::draw(float dt)
 {
-  
-
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
   glLoadIdentity(); // Reset the view
@@ -94,31 +92,33 @@
 	if (mouse1Down)
 	  {
-	    int mX = event.button.x;
-	    int mY = event.button.y;
-	    int wH = GraphicsEngine::getInstance()->getResolutionY();
-	    int wW = GraphicsEngine::getInstance()->getResolutionX();
-	    Vector tmpV (mX, mY, sqrt ( (float) abs(wH * wH/4 - (wW/2-mX) * (wW/2-mX) - (wH/2-mY) * (wH/2-mY)) ));
-	    //	    PRINTF(0)("tmpV: %f, %f, %f\n", tmpV.x, tmpV.y, tmpV.z);
-	    p2 = tmpV-M;
-	    p2.y = -p2.y;
-	    rotAxis = p1.cross(p2);
-	    //  PRINTF(0)("rotAxis: %f, %f, %f\n", rotAxis.x, rotAxis.y, rotAxis.z);
-
-	    // in case that there is no rotation-axis defined
-	    if (rotAxis.x != 0 || rotAxis.y != 0 || rotAxis.z != 0)
+	    /*
+	      int mX = event.button.x;
+	      int mY = event.button.y;
+	      int wH = GraphicsEngine::getInstance()->getResolutionY();
+	      int wW = GraphicsEngine::getInstance()->getResolutionX();
+	      Vector tmpV (mX, mY, sqrt ( (float) abs(wH * wH/4 - (wW/2-mX) * (wW/2-mX) - (wH/2-mY) * (wH/2-mY)) ));
+	      //	    PRINTF(0)("tmpV: %f, %f, %f\n", tmpV.x, tmpV.y, tmpV.z);
+	      p2 = tmpV-M;
+	      p2.y = -p2.y;
+	      rotAxis = p1.cross(p2);
+	      //  PRINTF(0)("rotAxis: %f, %f, %f\n", rotAxis.x, rotAxis.y, rotAxis.z);
+	      
+	      // in case that there is no rotation-axis defined
+	      if (rotAxis.x != 0 || rotAxis.y != 0 || rotAxis.z != 0)
 	      {
-		rotAxis.normalize();
-		//		PRINTF(0)("rotAxis: %f, %f, %f\n", rotAxis.x, rotAxis.y, rotAxis.z, rotAngle);
-				
-		rotAngle = angleRad (p1, p2);
-		rotQ = Quaternion (rotAngle, rotAxis);
-		rotQ = rotQ * rotQlast;
-		rotQ.matrix (matQ);
-		//	dir = rotQ.apply(dir);
-		//      dir.normalize();
-		//	PRINTF(0)("rotAxis: %f, %f, %f, %f\n", dir.x, dir.y, dir.z, rotAngle);
+	      rotAxis.normalize();
+	      //		PRINTF(0)("rotAxis: %f, %f, %f\n", rotAxis.x, rotAxis.y, rotAxis.z, rotAngle);
+	      
+	      rotAngle = angleRad (p1, p2);
+	      rotQ = Quaternion (rotAngle, rotAxis);
+	      rotQ = rotQ * rotQlast;
+	      rotQ.matrix (matQ);
+	      //	dir = rotQ.apply(dir);
+	      //      dir.normalize();
+	      //	PRINTF(0)("rotAxis: %f, %f, %f, %f\n", dir.x, dir.y, dir.z, rotAngle);
 	      }
-	    rotQlast = rotQ;
-	    p1 = p2;
+	      rotQlast = rotQ;
+	      p1 = p2;
+	    */
 
 	  }
@@ -172,5 +172,5 @@
 	  {
 	  case SDLK_x:
-
+	    
 	    break;
 	  case SDLK_c:
Index: /orxonox/branches/physics/src/world_entities/camera.h
===================================================================
--- /orxonox/branches/physics/src/world_entities/camera.h	(revision 4297)
+++ /orxonox/branches/physics/src/world_entities/camera.h	(revision 4298)
@@ -19,5 +19,5 @@
    This class controls the viewpoint from which the World is rendered.
 */
-class Camera : public PNode 
+class Camera : public PNode
 {
  private: