Index: orxonox/branches/physics/src/lib/graphics/particles/particle_emitter.cc
===================================================================
--- orxonox/branches/physics/src/lib/graphics/particles/particle_emitter.cc	(revision 4306)
+++ orxonox/branches/physics/src/lib/graphics/particles/particle_emitter.cc	(revision 4307)
@@ -37,5 +37,5 @@
    this->setSpread(angle);
    this->setEmissionRate(emissionRate);
-   this->setVelocity(velocity);
+   this->setEmissionVelocity(velocity);
 
    this->saveTime = 0.0;
@@ -119,5 +119,5 @@
    you may want to use the animation class
 */
-void ParticleEmitter::setVelocity(float velocity, float randomVelocity)
+void ParticleEmitter::setEmissionVelocity(float velocity, float randomVelocity)
 {
   this->velocity = velocity;
Index: orxonox/branches/physics/src/lib/graphics/particles/particle_emitter.h
===================================================================
--- orxonox/branches/physics/src/lib/graphics/particles/particle_emitter.h	(revision 4306)
+++ orxonox/branches/physics/src/lib/graphics/particles/particle_emitter.h	(revision 4307)
@@ -37,5 +37,16 @@
   void setEmissionRate(float emissionRate);
   void setSpread(float angle, float randomAngle = 0.0);
-  void setVelocity(float velocity, float randomVelocity = 0.0);
+  void setEmissionVelocity(float velocity, float randomVelocity = 0.0);
+
+  /** \returns the type of the emitter */
+  inline EMITTER_TYPE getType(void) const { return this->type; };
+  /** \returns the Size of the emitter */
+  inline float getSize(void) const { return this->emitterSize; };
+  /** \returns the emissionRate */
+  inline float getEmissionRate(void) const { return this->emissionRate; };
+  /** \returns the SpreadAngle of the emitter */
+  inline float getSpread(void) { return this->angle; };
+  /** \returns the EmissionVelocity of the emitter */
+  inline float getEmissionVelocity(void) { return this->velocity; };
 
   void debug(void);
Index: orxonox/branches/physics/src/lib/graphics/particles/particle_system.h
===================================================================
--- orxonox/branches/physics/src/lib/graphics/particles/particle_system.h	(revision 4306)
+++ orxonox/branches/physics/src/lib/graphics/particles/particle_system.h	(revision 4307)
@@ -78,4 +78,21 @@
 		GLfloat er, GLfloat eg, GLfloat eb, GLfloat ea);
 
+  /** \returns the Type of the particles */
+  inline PARTICLE_TYPE getType(void) const { return this->particleType; };
+  /** \returns the Material that lies on this particles */
+  inline const Material* getMaterial(void) const { return this->material; };
+  /** \returns the inherit-speed-factor */
+  inline float getInheritSpeed(void) const { return this->inheritSpeed; };
+  /** \returns the lifespan of the particles */
+  inline float getLifeSpan(void) const { return this->lifeSpan; };
+  /** \returns the starting-radius of the particles */
+  inline float getStartRadius(void) const { return this->startRadius; };
+  /** \returns the end-radius of the particles */
+  inline float getEndRadius(void) const { return this->endRadius; };
+  /** \returns the conserve-factor of the particles */
+  inline float getConserve(void) const { return this->conserve; };
+  /** \returns the initial mass of the particles */
+  inline float getMass(void) const { return this->initialMass; };
+
   void applyField(float dt, Field* field);
 
Index: orxonox/branches/physics/src/subprojects/particles/framework.cc
===================================================================
--- orxonox/branches/physics/src/subprojects/particles/framework.cc	(revision 4306)
+++ orxonox/branches/physics/src/subprojects/particles/framework.cc	(revision 4307)
@@ -168,4 +168,7 @@
 	    //zoomTo *=2;
 	    break;
+	  case SDLK_h:
+	    this->printHelp();
+	    break;
 	  }
 	break;
@@ -228,4 +231,25 @@
 }
 
+
+
+void Framework::printHelp(void) const
+{
+  PRINT(0)("Help for the frameWork \n");
+  PRINT(0)("----------------------");
+  PRINT(0)("h - print Help\n");
+  PRINT(0)("i - state Information\n");
+  PRINT(0)("1,2 - increase/decrease emissionRate\n");
+  PRINT(0)("3,4 - increase/decrease emission velocity\n");
+  PRINT(0)("5,6 - increase/decrease spread angle\n");
+  PRINT(0)("\n");
+  PRINT(0)("7,8 - increase-decrease emitter-size\n");
+  PRINT(0)("9 - swap emitterType\n");
+  PRINT(0)("\n");
+
+
+}
+
+
+
 int main(int argc, char *argv[])
 {
Index: orxonox/branches/physics/src/subprojects/particles/framework.h
===================================================================
--- orxonox/branches/physics/src/subprojects/particles/framework.h	(revision 4306)
+++ orxonox/branches/physics/src/subprojects/particles/framework.h	(revision 4307)
@@ -32,4 +32,6 @@
   float tick();
   bool keyHandler();
+
+  void printHelp(void) const;
 };
 #endif /* _FRAMEWORK_H */